<?php
	/*
		Befüllt die Tabellen uid_changes oder uid_changes_multiple (abhängig vom Wert von $daily_only) mit Veränderungswerten einzelner UIDs.
	*/


	require('inc.php');
	$daily_only = true;		// Falls true wird nur ein Datensatz pro Tag gezählt
	$table = ($daily_only ? 'uid_changes' : 'uid_changes_multiple');
	$sql = "SELECT COUNT(*) FROM $table;";
	$result = mysql_query($sql);
	if (mysql_result($result, 0, 0) != 0)
		die("$table nicht leer.\n");

	$changes = array('ip' => 0,'port' => 0,'http_referrer' => 0,'http_user_agent' => 0,'http_accept' => 0,'http_accept_charset' => 0,'http_accept_encoding' => 0,'http_accept_language' => 0,'png_id' => 0,'document_referrer' => 0,'navigator_appCodeName' => 0,'navigator_appName' => 0,'navigator_appVersion' => 0,'navigator_cookieEnabled' => 0,'navigator_language' => 0,'navigator_platform' => 0,'navigator_userAgent' => 0,'screen_width' => 0,'screen_height' => 0,'screen_avail_width' => 0,'screen_avail_height' => 0,'color_depth' => 0,'dpi_x' => 0,'dpi_y' => 0,'devicePixelRatio' => 0,'timezone_offset' => 0,'java_enabled' => 0,'color_activeborder' => 0,'color_activecaption' => 0,'color_appworkspace' => 0,'color_background' => 0,'color_buttonface' => 0,'color_buttonhighlight' => 0,'color_buttonshadow' => 0,'color_buttontext' => 0,'color_captiontext' => 0,'color_graytext' => 0,'color_highlight' => 0,'color_highlighttext' => 0,'color_inactiveborder' => 0,'color_inactivecaption' => 0,'color_inactivecaptiontext' => 0,'color_infobackground' => 0,'color_infotext' => 0,'color_menu' => 0,'color_menutext' => 0,'color_scrollbar' => 0,'color_threeddarkshadow' => 0,'color_threedface' => 0,'color_threedhighlight' => 0,'color_threedlightshadow' => 0,'color_threedshadow' => 0,'color_window' => 0,'color_windowframe' => 0,'color_windowtext' => 0,'plugin_flash' => 0,'plugin_adobe_acrobat' => 0,'plugin_silverlight' => 0,'plugins' => 0,'mimetypes' => 0,'fonts' => 0,'plugins_notnull' => 0,'mimetypes_notnull' => 0,'fonts_notnull' => 0);


	// Welche UIDs wurden zwei Mal aufgerufen?
	$sql = "SELECT uid, COUNT(*) FROM bfp GROUP BY uid HAVING COUNT(uid) >= 2";
	$result_uids = mysql_query($sql);
	$uids_total = mysql_num_rows($result_uids);
	$n = 0;
	$manipulations = 0;
	
	echo "UID Anzahl: $uids_total \n\n";
	
	while ($r_uid = mysql_fetch_row($result_uids)) {
		$uid = $r_uid[0];
		$uid_count = $r_uid[1];
		$n ++;

		echo $n . "/" . $uids_total . "\t" . "=== $uid ($uid_count) ===\n";

		$sql = "SELECT * FROM bfp WHERE uid = '$uid' ORDER BY id ASC";
		$result_this_uid = mysql_query($sql);
		
		$null_count = 0;
		$r_old = false;
		$dt_first = false;
		$dt_last = false;
		$last_day = 0;
		$plugins = '';
		$mimetypes = '';
		$fonts = '';
		$platform = '';
		
		$sql = "INSERT INTO $table (uid) VALUES ('$uid');";
		$result = mysql_query($sql);
		
		// Changes auf null setzen
		foreach ($changes as &$value) {
			$value = 0;
		}

		while ($r = mysql_fetch_row($result_this_uid)) {
			$dt_last = $r[2];
			if ($r_old === false) {		// Erster Durchlauf
				if ($r[13] != null) {
					$dt_first = $r[2];
					$last_day = date('d', strtotime($r[2]));
					$r_old = $r;
					$platform = $r[18];
				}
			} else {
				if ((date('d', strtotime($r[2])) != $last_day) || !$daily_only) {

						
					if ($r[13] == null) {	// Fehlerhafter Datensatz 
						$null_count++;
					} else {

						
						if ($platform != $r[18])
							$platform = "ERR!";
											
						for ($i = 3; $i < sizeof($r); $i++) {
							if ($r[$i] != $r_old[$i]) {
								if ($i != 62 && $i != 64 && $i != 66) {		// Hash-Einträge ignorieren
									$changes[mysql_field_name($result_this_uid, $i)]++;
								}
							}														
						}
						$r_old = $r;
						$last_day = date('d', strtotime($r[2]));
					}
				} else {
					$uid_count--;
					echo "DAY-SKIP!\n";
				}
			}

			// Falls nicht erster Durchlauf (plugins == '') und Plugins tatsächlich anders als voriger Wert (NULL ignorieren), dann erhöhen (gleiches gilt für mimetypes und fonts)
				
			if ($plugins != '' && ($r[61] != null && $r[61] != $plugins))
				$changes['plugins_notnull']++;

			if ($mimetypes != '' && ($r[63] != null && $r[63] != $mimetypes))
				$changes['mimetypes_notnull']++;

			if ($fonts != '' && ($r[65] != null && $r[65] != $fonts)) 
				$changes['fonts_notnull']++;

			
			// Setze Plugins, Mimetypes, Fonts -- falls aktueller Wert != null. So können Veränderungen protokolliert werden, die nur durch valide (!= null) Datensätze entstehen
			if ($r[61] != null)
				$plugins = $r[61];
			if ($r[63] != null)
				$mimetypes = $r[63];
			if ($r[65] != null)
				$fonts = $r[65];
			
		}
		
		
		$sql = "UPDATE $table SET uid = '$uid', uid_count = $uid_count, null_count = $null_count, dt_first = '$dt_first', dt_last = '$dt_last', ";
		
		$keys = array_keys($changes);

		foreach($keys as $key) {
			$sql .= $key . ' = ' . $changes[$key] . ', ';
		}
		
		$sql = substr($sql, 0, -2);
		$sql .= " WHERE uid = '$uid';";
		if ($platform != 'ERR!' && $uid_count > 1) {
			$result = mysql_query($sql);
		} elseif ($platform == 'ERR!') {
			$result = mysql_query("DELETE FROM $table WHERE uid = '$uid'");
			echo "!! MANIPULIERTE UID !!\n";
			$manipulations++;
		} else {		// Nur ein uid_count (bei $daily_only = true und mehrfacher Verwendung an nur einem Tag möglich)
			$result = mysql_query("DELETE FROM $table WHERE uid = '$uid'");
			echo "uid_count = 1!\n";			
		}

		if ($result) {
			echo "OK\n\n";
		} else {
			die (mysql_errno() . ": " . mysql_error() . "\n");
		}
	}
	echo "Manipulierte Datensätze: $manipulations \n\n";
	
?>
	